/[gentoo-x86]/eclass/gnome2.eclass
Gentoo

Diff of /eclass/gnome2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.76 Revision 1.114
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/gnome2.eclass,v 1.76 2006/12/07 03:13:25 compnerd Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/gnome2.eclass,v 1.114 2012/11/27 00:48:01 tetromino Exp $
4 4
5# GNOME 2 ECLASS 5# @ECLASS: gnome2.eclass
6inherit libtool gnome.org debug fdo-mime eutils 6# @MAINTAINER:
7# gnome@gentoo.org
8# @BLURB:
9# @DESCRIPTION:
10# Exports portage base functions used by ebuilds written for packages using the
11# GNOME framework. For additional functions, see gnome2-utils.eclass.
7 12
13inherit eutils fdo-mime libtool gnome.org gnome2-utils
14
15case "${EAPI:-0}" in
16 0|1)
17 EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_preinst pkg_postinst pkg_postrm
18 ;;
19 2|3|4|5)
20 EXPORT_FUNCTIONS src_unpack src_prepare src_configure src_compile src_install pkg_preinst pkg_postinst pkg_postrm
21 ;;
22 *) die "EAPI=${EAPI} is not supported" ;;
23esac
24
25# @ECLASS-VARIABLE: G2CONF
26# @DEFAULT-UNSET
27# @DESCRIPTION:
8# Extra configure opts passed to econf 28# Extra configure opts passed to econf
9G2CONF=${G2CONF:=""} 29G2CONF=${G2CONF:-""}
10 30
31# @ECLASS-VARIABLE: GNOME2_LA_PUNT
32# @DESCRIPTION:
33# Should we delete ALL the .la files?
34# NOT to be used without due consideration.
35if has ${EAPI:-0} 0 1 2 3 4; then
36 GNOME2_LA_PUNT=${GNOME2_LA_PUNT:-"no"}
37else
38 GNOME2_LA_PUNT=${GNOME2_LA_PUNT:-""}
39fi
40
41# @ECLASS-VARIABLE: ELTCONF
42# @DEFAULT-UNSET
43# @DESCRIPTION:
11# Extra options passed to elibtoolize 44# Extra options passed to elibtoolize
12ELTCONF=${ELTCONF:=""} 45ELTCONF=${ELTCONF:-""}
13 46
47# @ECLASS-VARIABLE: USE_EINSTALL
48# @DEFAULT-UNSET
49# @DEPRECATED
50# @DESCRIPTION:
14# Should we use EINSTALL instead of DESTDIR 51# Should we use EINSTALL instead of DESTDIR
15USE_EINSTALL=${USE_EINSTALL:=""} 52USE_EINSTALL=${USE_EINSTALL:-""}
16 53
54# @ECLASS-VARIABLE: SCROLLKEEPER_UPDATE
55# @DEPRECATED
56# @DESCRIPTION:
17# Run scrollkeeper for this package? 57# Whether to run scrollkeeper for this package or not.
18SCROLLKEEPER_UPDATE=${SCROLLKEEPER_UPDATE:="1"} 58SCROLLKEEPER_UPDATE=${SCROLLKEEPER_UPDATE:-"1"}
19 59
20# Where to put scrollkeeper data lives 60# @ECLASS-VARIABLE: DOCS
21SCROLLKEEPER_DIR=${SCROLLKEEPER_DIR:="/var/lib/scrollkeeper"} 61# @DEFAULT-UNSET
62# @DESCRIPTION:
63# String containing documents passed to dodoc command.
22 64
23# Path to scrollkeeper-update 65# @ECLASS-VARIABLE: GCONF_DEBUG
24SCROLLKEEPER_UPDATE_BIN=${SCROLLKEEPER_UPDATE_BIN:="${ROOT}/usr/bin/scrollkeeper-update"} 66# @DEFAULT_UNSET
67# @DESCRIPTION:
68# Whether to handle debug or not.
69# Some gnome applications support various levels of debugging (yes, no, minimum,
70# etc), but using --disable-debug also removes g_assert which makes debugging
71# harder. This variable should be set to yes for such packages for the eclass
72# to handle it properly. It will enable minimal debug with USE=-debug.
73# Note that this is most commonly found in configure.ac as GNOME_DEBUG_CHECK.
25 74
26# Path to gconftool-2
27GCONFTOOL_BIN=${GCONFTOOL_BIN:="${ROOT}/usr/bin/gconftool-2"}
28 75
29if [[ ${GCONF_DEBUG} != "no" ]]; then 76if [[ ${GCONF_DEBUG} != "no" ]]; then
30 IUSE="debug" 77 IUSE="debug"
31fi 78fi
32 79
33DEPEND=">=sys-apps/sed-4"
34 80
81# @FUNCTION: gnome2_src_unpack
82# @DESCRIPTION:
83# Stub function for old EAPI.
35gnome2_src_unpack() { 84gnome2_src_unpack() {
36 unpack ${A} 85 unpack ${A}
37 cd ${S} 86 cd "${S}"
87 has ${EAPI:-0} 0 1 && gnome2_src_prepare
88}
89
90# @FUNCTION: gnome2_src_prepare
91# @DESCRIPTION:
92# Prepare environment for build, fix build of scrollkeeper documentation,
93# run elibtoolize.
94gnome2_src_prepare() {
95 # Prevent assorted access violations and test failures
96 gnome2_environment_reset
38 97
39 # Prevent scrollkeeper access violations 98 # Prevent scrollkeeper access violations
40 gnome2_omf_fix 99 gnome2_omf_fix
41}
42 100
101 # Disable all deprecation warnings
102 gnome2_disable_deprecation_warning
103
104 # Run libtoolize
105 if has ${EAPI:-0} 0 1 2 3; then
106 elibtoolize ${ELTCONF}
107 else
108 # Everything is fatal EAPI 4 onwards
109 nonfatal elibtoolize ${ELTCONF}
110 fi
111
112}
113
114# @FUNCTION: gnome2_src_configure
115# @DESCRIPTION:
116# Gnome specific configure handling
43gnome2_src_configure() { 117gnome2_src_configure() {
44 # Update the GNOME configuration options 118 # Update the GNOME configuration options
45 if [[ ${GCONF_DEBUG} != 'no' ]] ; then 119 if [[ ${GCONF_DEBUG} != 'no' ]] ; then
46 if use debug ; then 120 if use debug ; then
47 G2CONF="${G2CONF} --enable-debug=yes" 121 G2CONF="${G2CONF} --enable-debug=yes"
48 fi 122 fi
49 fi 123 fi
50 124
51 # Prevent a QA warning 125 # Prevent a QA warning
52 if hasq doc ${IUSE} ; then 126 if has doc ${IUSE} ; then
53 G2CONF="${G2CONF} $(use_enable doc gtk-doc)" 127 grep -q "enable-gtk-doc" configure && G2CONF="${G2CONF} $(use_enable doc gtk-doc)"
128 fi
129
130 # Pass --disable-maintainer-mode when needed
131 if grep -q "^[[:space:]]*AM_MAINTAINER_MODE(\[enable\])" configure.*; then
132 G2CONF="${G2CONF} --disable-maintainer-mode"
133 fi
134
135 # Pass --disable-scrollkeeper when possible
136 if grep -q "disable-scrollkeeper" configure; then
137 G2CONF="${G2CONF} --disable-scrollkeeper"
138 fi
139
140 # Pass --disable-silent-rules when possible (not needed for eapi5), bug #429308
141 if has ${EAPI:-0} 0 1 2 3 4; then
142 if grep -q "disable-silent-rules" configure; then
143 G2CONF="${G2CONF} --disable-silent-rules"
54 fi 144 fi
145 fi
55 146
56 # Run libtoolize 147 # Pass --disable-schemas-install when possible
57 elibtoolize ${ELTCONF} 148 if grep -q "disable-schemas-install" configure; then
149 G2CONF="${G2CONF} --disable-schemas-install"
150 fi
58 151
59 # Do not remove the addwrite. bug #128289 152 # Avoid sandbox violations caused by gnome-vfs (bug #128289 and #345659)
60 addwrite "${ROOT}/root/.gnome2" 153 addwrite "$(unset HOME; echo ~)/.gnome2"
61 154
62 # GST_REGISTRY is to work around gst-inspect trying to read/write /root 155 econf "$@" ${G2CONF}
63 GST_REGISTRY="${S}/registry.xml" econf "$@" ${G2CONF} || die "configure failed"
64} 156}
65 157
158# @FUNCTION: gnome2_src_compile
159# @DESCRIPTION:
160# Stub function for old EAPI.
66gnome2_src_compile() { 161gnome2_src_compile() {
67 gnome2_src_configure "$@" 162 has ${EAPI:-0} 0 1 && gnome2_src_configure "$@"
68 emake || die "compile failure" 163 emake || die "compile failure"
69} 164}
70 165
166# @FUNCTION: gnome2_src_install
167# @DESCRIPTION:
168# Gnome specific install. Handles typical GConf and scrollkeeper setup
169# in packages and removal of .la files if requested
71gnome2_src_install() { 170gnome2_src_install() {
171 has ${EAPI:-0} 0 1 2 && ! use prefix && ED="${D}"
72 # if this is not present, scrollkeeper-update may segfault and 172 # if this is not present, scrollkeeper-update may segfault and
73 # create bogus directories in /var/lib/ 173 # create bogus directories in /var/lib/
74 dodir "${SCROLLKEEPER_DIR}" 174 local sk_tmp_dir="/var/lib/scrollkeeper"
175 dodir "${sk_tmp_dir}" || die "dodir failed"
75 176
76 # we must delay gconf schema installation due to sandbox 177 # we must delay gconf schema installation due to sandbox
77 export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL="1" 178 export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL="1"
78 179
79 debug-print "You are testing with DESTDIR by default - AllanonJL"
80 if [[ -z "${USE_EINSTALL}" || "${USE_EINSTALL}" = "0" ]]; then 180 if [[ -z "${USE_EINSTALL}" || "${USE_EINSTALL}" = "0" ]]; then
181 debug-print "Installing with 'make install'"
81 make DESTDIR=${D} "scrollkeeper_localstate_dir=${D}${SCROLLKEEPER_DIR} " "$@" install || die "install failed" 182 emake DESTDIR="${D}" "scrollkeeper_localstate_dir=${ED}${sk_tmp_dir} " "$@" install || die "install failed"
82 else 183 else
184 debug-print "Installing with 'einstall'"
83 einstall "scrollkeeper_localstate_dir=${D}${SCROLLKEEPER_DIR} " "$@" || die "einstall failed" 185 einstall "scrollkeeper_localstate_dir=${ED}${sk_tmp_dir} " "$@" || die "einstall failed"
84 fi 186 fi
85 187
86 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL 188 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
87 189
190 # Handle documentation as 'default' for eapi5 and newer, bug #373131
191 if has ${EAPI:-0} 0 1 2 3 4; then
88 # Manual document installation 192 # Manual document installation
193 if [[ -n "${DOCS}" ]]; then
194 dodoc ${DOCS} || die "dodoc failed"
195 fi
196 else
197 if ! declare -p DOCS >/dev/null 2>&1 ; then
198 local d
199 for d in README* ChangeLog AUTHORS NEWS TODO CHANGES THANKS BUGS \
200 FAQ CREDITS CHANGELOG ; do
89 [[ -n "${DOCS}" ]] && dodoc ${DOCS} 201 [[ -s "${d}" ]] && dodoc "${d}"
202 done
203 elif declare -p DOCS | grep -q '^declare -a' ; then
204 dodoc "${DOCS[@]}"
205 else
206 dodoc ${DOCS}
207 fi
208 fi
90 209
91 # Do not keep /var/lib/scrollkeeper because: 210 # Do not keep /var/lib/scrollkeeper because:
92 # 1. scrollkeeper will get regenerated at pkg_postinst() 211 # 1. The scrollkeeper database is regenerated at pkg_postinst()
93 # 2. ${D}/var/lib/scrollkeeper contains only indexes for the current pkg 212 # 2. ${ED}/var/lib/scrollkeeper contains only indexes for the current pkg
94 # thus it makes no sense if pkg_postinst ISN'T run for some reason. 213 # thus it makes no sense if pkg_postinst ISN'T run for some reason.
95 214 rm -rf "${ED}${sk_tmp_dir}"
96 if [[ -z "$(find ${D} -name '*.omf')" ]]; then 215 rmdir "${ED}/var/lib" 2>/dev/null
97 export SCROLLKEEPER_UPDATE="0" 216 rmdir "${ED}/var" 2>/dev/null
98 fi
99
100 # Regenerate these in pkg_postinst()
101 rm -rf "${D}${SCROLLKEEPER_DIR}"
102 217
103 # Make sure this one doesn't get in the portage db 218 # Make sure this one doesn't get in the portage db
104 rm -fr "${D}/usr/share/applications/mimeinfo.cache" 219 rm -fr "${ED}/usr/share/applications/mimeinfo.cache"
105}
106 220
107 221 # Delete all .la files
108gnome2_gconf_install() { 222 if has ${EAPI:-0} 0 1 2 3 4; then
109 223 if [[ "${GNOME2_LA_PUNT}" != "no" ]]; then
110 if [[ -x ${GCONFTOOL_BIN} ]]; then 224 ebegin "Removing .la files"
111 # We are ready to install the GCONF Scheme now 225 if ! { has static-libs ${IUSE//+} && use static-libs; }; then
112 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL 226 find "${D}" -name '*.la' -exec rm -f {} + || die "la file removal failed"
113 export GCONF_CONFIG_SOURCE=$(${GCONFTOOL_BIN} --get-default-source)
114
115 einfo "Installing GNOME 2 GConf schemas"
116
117 local contents="${ROOT}/var/db/pkg/*/${PN}-${PVR}/CONTENTS"
118
119 for F in $(grep "^obj /etc/gconf/schemas/.\+\.schemas\b" ${contents} | gawk '{print $2}' ); do
120 if [[ -e "${F}" ]]; then
121 # echo "DEBUG::gconf install ${F}"
122 ${GCONFTOOL_BIN} --makefile-install-rule ${F} 1>/dev/null
123 fi 227 fi
124 done
125
126 # have gconf reload the new schemas
127 ebegin "Reloading GConf schemas"
128 killall -HUP gconfd-2
129 eend $?
130 fi
131
132}
133
134gnome2_gconf_uninstall() {
135 if [[ -x ${GCONFTOOL_BIN} ]]; then
136 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
137 export GCONF_CONFIG_SOURCE=$(${GCONFTOOL_BIN} --get-default-source)
138
139 einfo "Uninstalling GNOME 2 GConf schemas"
140
141 local contents="${ROOT}/var/db/pkg/*/${PN}-${PVR}/CONTENTS"
142
143 for F in $(grep "obj /etc/gconf/schemas" ${contents} | sed 's:obj \([^ ]*\) .*:\1:' ); do
144 # echo "DEBUG::gconf install ${F}"
145 ${GCONFTOOL_BIN} --makefile-uninstall-rule ${F} 1>/dev/null
146 done
147 fi
148}
149
150gnome2_icon_cache_update() {
151 local updater=$(type -p gtk-update-icon-cache 2> /dev/null)
152
153 ebegin "Updating icons cache"
154
155 if [[ ! -x ${updater} ]] ; then
156 debug-print "${updater} is not executable"
157
158 # We failed to run
159 eend 1 228 eend
160
161 return
162 fi
163
164 if ! grep -q "obj /usr/share/icons" ${ROOT}/var/db/pkg/*/${PF}/CONTENTS
165 then
166 debug-print "No items to update"
167
168 # We are done successfully
169 eend 0
170
171 return
172 fi
173
174 local retval=0
175 local fails=( )
176
177 for dir in $(find ${ROOT}/usr/share/icons -maxdepth 1 -mindepth 1 -type d)
178 do
179 if [[ -f "${dir}/index.theme" ]] ; then
180 local rv=0
181
182 ${updater} -qf ${dir}
183 rv=$?
184
185 if [[ ! $rv -eq 0 ]] ; then
186 debug-print "Updating cache failed on ${dir}"
187
188 # Add to the list of failures
189 fails[$(( ${#fails[@]} + 1 ))]=$dir
190
191 retval=2
192 fi 229 fi
230 else
231 case "${GNOME2_LA_PUNT}" in
232 yes) prune_libtool_files --modules;;
233 no) ;;
234 *) prune_libtool_files;;
235 esac
193 fi 236 fi
194 done
195
196 eend ${retval}
197
198 for (( i = 0 ; i < ${#fails[@]} ; i++ )) ; do
199 ### HACK!! This is needed until bash 3.1 is unmasked.
200 ## The current stable version of bash lists the sizeof fails to be 1
201 ## when there are no elements in the list because it is declared local.
202 ## In order to prevent the declaration from being in global scope, we
203 ## this hack to prevent an empty error message being printed for stable
204 ## users. -- compnerd && allanonjl
205 if [[ "${fails[i]}" != "" && "${fails[i]}" != "()" ]] ; then
206 eerror "Failed to update cache with icon ${fails[i]}"
207 fi
208 done
209} 237}
210 238
211gnome2_omf_fix() { 239# @FUNCTION: gnome2_pkg_preinst
212 # workaround/patch against omf.make or omf-install/Makefile.in 240# @DESCRIPTION:
213 # in order to remove redundant scrollkeeper-updates. 241# Finds Icons, GConf and GSettings schemas for later handling in pkg_postinst
214 # - <liquidx@gentoo.org> 242gnome2_pkg_preinst() {
215 243 gnome2_gconf_savelist
216 local omf_makefiles filename 244 gnome2_icon_savelist
217 245 gnome2_schemas_savelist
218 omf_makefiles="$@" 246 gnome2_scrollkeeper_savelist
219
220 if [[ -f ${S}/omf-install/Makefile.in ]] ; then
221 omf_makefiles="${omf_makefiles} ${S}/omf-install/Makefile.in"
222 fi
223
224 # FIXME: does this really work? because omf.make only gets included
225 # when autoconf/automake is run. You should directly patch
226 # the Makefile.in's
227
228 if [[ -f ${S}/omf.make ]] ; then
229 omf_makefiles="${omf_makefiles} ${S}/omf.make"
230 fi
231
232 # testing fixing of all makefiles found
233 for filename in $(find ./ -name "Makefile.in" -o -name "Makefile.am") ; do
234 omf_makefiles="${omf_makefiles} ${filename}"
235 done
236
237 ebegin "Fixing OMF Makefiles"
238
239 local retval=0
240 local fails=( )
241
242 for omf in ${omf_makefiles} ; do
243 local rv=0
244
245 sed -i -e 's:scrollkeeper-update:true:' ${omf}
246 retval=$?
247
248 if [[ ! $rv -eq 0 ]] ; then
249 debug-print "updating of ${omf} failed"
250
251 # Add to the list of failures
252 fails[$(( ${#fails[@]} + 1 ))]=$omf
253
254 retval=2
255 fi
256 done
257
258 eend $retval
259
260 for (( i = 0 ; i < ${#fails[@]} ; i++ )) ; do
261 ### HACK!! This is needed until bash 3.1 is unmasked.
262 ## The current stable version of bash lists the sizeof fails to be 1
263 ## when there are no elements in the list because it is declared local.
264 ## In order to prevent the declaration from being in global scope, we
265 ## this hack to prevent an empty error message being printed for stable
266 ## users. -- compnerd && allanonjl
267 if [[ "${fails[i]}" != "" && "${fails[i]}" != "()" ]] ; then
268 eerror "Failed to update OMF Makefile ${fails[i]}"
269 fi
270 done
271} 247}
272 248
273gnome2_scrollkeeper_update() { 249# @FUNCTION: gnome2_pkg_postinst
274 if [[ -x ${SCROLLKEEPER_UPDATE_BIN} && "${SCROLLKEEPER_UPDATE}" = "1" ]] 250# @DESCRIPTION:
275 then 251# Handle scrollkeeper, GConf, GSettings, Icons, desktop and mime
276 einfo "Updating scrollkeeper database ..." 252# database updates.
277 ${SCROLLKEEPER_UPDATE_BIN} -q -p ${ROOT}${SCROLLKEEPER_DIR}
278 fi
279}
280
281gnome2_pkg_postinst() { 253gnome2_pkg_postinst() {
282 gnome2_gconf_install 254 gnome2_gconf_install
283 gnome2_scrollkeeper_update
284 fdo-mime_desktop_database_update 255 fdo-mime_desktop_database_update
285 fdo-mime_mime_database_update 256 fdo-mime_mime_database_update
286 gnome2_icon_cache_update 257 gnome2_icon_cache_update
258 gnome2_schemas_update
259 gnome2_scrollkeeper_update
287} 260}
288 261
262# @#FUNCTION: gnome2_pkg_prerm
263# @#DESCRIPTION:
264# # FIXME Handle GConf schemas removal
289#gnome2_pkg_prerm() { 265#gnome2_pkg_prerm() {
290# gnome2_gconf_uninstall 266# gnome2_gconf_uninstall
291#} 267#}
292 268
269# @FUNCTION: gnome2_pkg_postrm
270# @DESCRIPTION:
271# Handle scrollkeeper, GSettings, Icons, desktop and mime database updates.
293gnome2_pkg_postrm() { 272gnome2_pkg_postrm() {
294 gnome2_scrollkeeper_update
295 fdo-mime_desktop_database_update 273 fdo-mime_desktop_database_update
296 fdo-mime_mime_database_update 274 fdo-mime_mime_database_update
297 gnome2_icon_cache_update 275 gnome2_icon_cache_update
276 gnome2_schemas_update
277 gnome2_scrollkeeper_update
298} 278}
299
300EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_postinst pkg_postrm

Legend:
Removed from v.1.76  
changed lines
  Added in v.1.114

  ViewVC Help
Powered by ViewVC 1.1.20